<!-- 
PluginName: Synonyms
PluginUrl: https://ioctopus.online/inserting-synonyms
Version: 1.0

Synonyms Api: https://words.bighugelabs.com/site/api
-->

<script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>




<script>
{
	// Get Synonims From Api
	// https://rapidapi.com/dpventures/api/wordsapi/
	const getSynonym = (text, callback) => {
	
		var options = {
			method: 'GET',
			url: 'https://words.bighugelabs.com/api/2/73fdfae42712324a91cbe21daad99a88/'+text+'/json',
		};

		axios.request(options).then(function (response) {
			callback(response.data?.noun?.syn || []);
		}).catch(function (error) {
			console.error(error);
		});
	}
	
	
	// Add Synonyms To Selected Branches
	const addSynonymsToSelectedBranches = () => {
	
		// Each selected branches
		for(let branch of ioctopus.getSelectedBranches()) {
			
			branch.loading();
			
			// Branch text
			let text = branch.getText();
			
			// Synonyms
			getSynonym(text, synonyms => {
			
				// Each synonyms
				for (let synonym of synonyms) {
					
					// Create Sub Branch
					branch.addChild({
						content: {
							text: synonym,
						}
					});
				}
				
				branch.loadingStop();
			});
		}
	};
	
	
	// Context Menu
	ioctopus.$on('context-menu', contextMenu => {
		contextMenu.add({
			label: "Add Synonyms",
			icon: "fas fa-list-ul",
			click: addSynonymsToSelectedBranches,
			keycode: "Alt+Shift+S",
		});
	});
	

	// Alt + Shift + S
	ioctopus.$on('keydown', e => {	
		if (e.altKey && e.shiftKey && e.keyCode === 83) {
			e.preventDefault();
			
			addSynonymsToSelectedBranches();
		}
	});
}
</script>



<style>

</style>
